/***************************************************************************
 *   Copyright (C) 2010 by                                                 *
 *                                                                         *
 *   catWorkX GmbH, Schellerdamm 16, 21079 Hamburg                         *                                                                         
 *   Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>                    *
 *                                                                         *
 *   This code is part of the Zarafa 2 LDAP tool, which is able to export  *
 *   private and/or public contacts from Zarafa to a LDAP server           * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Affero General Public License as        *
 *   published by the Free Software Foundation; either version 3           *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU AFFERO GENERAL PUBLIC LICENSE for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Affero General Public      *
 *   License along with this program.  If not, see                         *
 *   <http://www.gnu.org/licenses/>                                        *
 *                                                                         *
 ***************************************************************************/


package de.catworkx.zarafa.zarafa2ldap;

public class Contact implements java.io.Serializable {
    private java.lang.String uid;

    private java.lang.String email1Address;

    private java.lang.String email2Address;

    private java.lang.String email3Address;

    private java.lang.String displayName;

    private java.lang.String surname;

    private java.lang.String givenname;

    private java.lang.String mobile;

    private java.lang.String telephoneNumber;

    private java.lang.String facsimileTelephoneNumber;

    private java.lang.String o;

    private java.lang.String ou;

    private java.lang.String street;

    private java.lang.String postalAddress;

    private java.lang.String postalCode;

    private java.lang.String homePostalAddress;

    private java.lang.String title;

    private java.lang.String homePhone;

    private java.lang.String description;

    private java.lang.String secretary;

    private java.lang.String pager;

    private java.lang.String employeeType;

    public Contact() {
    }

    public Contact(
           java.lang.String uid,
           java.lang.String email1Address,
           java.lang.String email2Address,
           java.lang.String email3Address,
           java.lang.String displayName,
           java.lang.String surname,
           java.lang.String givenname,
           java.lang.String mobile,
           java.lang.String telephoneNumber,
           java.lang.String facsimileTelephoneNumber,
           java.lang.String o,
           java.lang.String ou,
           java.lang.String street,
           java.lang.String postalAddress,
           java.lang.String postalCode,
           java.lang.String homePostalAddress,
           java.lang.String title,
           java.lang.String homePhone,
           java.lang.String description,
           java.lang.String secretary,
           java.lang.String pager,
           java.lang.String employeeType) {
           this.uid = uid;
           this.email1Address = email1Address;
           this.email2Address = email2Address;
           this.email3Address = email3Address;
           this.displayName = displayName;
           this.surname = surname;
           this.givenname = givenname;
           this.mobile = mobile;
           this.telephoneNumber = telephoneNumber;
           this.facsimileTelephoneNumber = facsimileTelephoneNumber;
           this.o = o;
           this.ou = ou;
           this.street = street;
           this.postalAddress = postalAddress;
           this.postalCode = postalCode;
           this.homePostalAddress = homePostalAddress;
           this.title = title;
           this.homePhone = homePhone;
           this.description = description;
           this.secretary = secretary;
           this.pager = pager;
           this.employeeType = employeeType;
    }


    /**
     * Gets the uid value for this Contact.
     * 
     * @return uid
     */
    public java.lang.String getUid() {
        return uid;
    }


    /**
     * Sets the uid value for this Contact.
     * 
     * @param uid
     */
    public void setUid(java.lang.String uid) {
        this.uid = uid;
    }


    /**
     * Gets the email1Address value for this Contact.
     * 
     * @return email1Address
     */
    public java.lang.String getEmail1Address() {
        return email1Address;
    }


    /**
     * Sets the email1Address value for this Contact.
     * 
     * @param email1Address
     */
    public void setEmail1Address(java.lang.String email1Address) {
        this.email1Address = email1Address;
    }


    /**
     * Gets the email2Address value for this Contact.
     * 
     * @return email2Address
     */
    public java.lang.String getEmail2Address() {
        return email2Address;
    }


    /**
     * Sets the email2Address value for this Contact.
     * 
     * @param email2Address
     */
    public void setEmail2Address(java.lang.String email2Address) {
        this.email2Address = email2Address;
    }


    /**
     * Gets the email3Address value for this Contact.
     * 
     * @return email3Address
     */
    public java.lang.String getEmail3Address() {
        return email3Address;
    }


    /**
     * Sets the email3Address value for this Contact.
     * 
     * @param email3Address
     */
    public void setEmail3Address(java.lang.String email3Address) {
        this.email3Address = email3Address;
    }


    /**
     * Gets the displayName value for this Contact.
     * 
     * @return displayName
     */
    public java.lang.String getDisplayName() {
        return displayName;
    }


    /**
     * Sets the displayName value for this Contact.
     * 
     * @param displayName
     */
    public void setDisplayName(java.lang.String displayName) {
        this.displayName = displayName;
    }


    /**
     * Gets the surname value for this Contact.
     * 
     * @return surname
     */
    public java.lang.String getSurname() {
        return surname;
    }


    /**
     * Sets the surname value for this Contact.
     * 
     * @param surname
     */
    public void setSurname(java.lang.String surname) {
        this.surname = surname;
    }


    /**
     * Gets the givenname value for this Contact.
     * 
     * @return givenname
     */
    public java.lang.String getGivenname() {
        return givenname;
    }


    /**
     * Sets the givenname value for this Contact.
     * 
     * @param givenname
     */
    public void setGivenname(java.lang.String givenname) {
        this.givenname = givenname;
    }


    /**
     * Gets the mobile value for this Contact.
     * 
     * @return mobile
     */
    public java.lang.String getMobile() {
        return mobile;
    }


    /**
     * Sets the mobile value for this Contact.
     * 
     * @param mobile
     */
    public void setMobile(java.lang.String mobile) {
        this.mobile = mobile;
    }


    /**
     * Gets the telephoneNumber value for this Contact.
     * 
     * @return telephoneNumber
     */
    public java.lang.String getTelephoneNumber() {
        return telephoneNumber;
    }


    /**
     * Sets the telephoneNumber value for this Contact.
     * 
     * @param telephoneNumber
     */
    public void setTelephoneNumber(java.lang.String telephoneNumber) {
        this.telephoneNumber = telephoneNumber;
    }


    /**
     * Gets the facsimileTelephoneNumber value for this Contact.
     * 
     * @return facsimileTelephoneNumber
     */
    public java.lang.String getFacsimileTelephoneNumber() {
        return facsimileTelephoneNumber;
    }


    /**
     * Sets the facsimileTelephoneNumber value for this Contact.
     * 
     * @param facsimileTelephoneNumber
     */
    public void setFacsimileTelephoneNumber(java.lang.String facsimileTelephoneNumber) {
        this.facsimileTelephoneNumber = facsimileTelephoneNumber;
    }


    /**
     * Gets the o value for this Contact.
     * 
     * @return o
     */
    public java.lang.String getO() {
        return o;
    }


    /**
     * Sets the o value for this Contact.
     * 
     * @param o
     */
    public void setO(java.lang.String o) {
        this.o = o;
    }


    /**
     * Gets the ou value for this Contact.
     * 
     * @return ou
     */
    public java.lang.String getOu() {
        return ou;
    }


    /**
     * Sets the ou value for this Contact.
     * 
     * @param ou
     */
    public void setOu(java.lang.String ou) {
        this.ou = ou;
    }


    /**
     * Gets the street value for this Contact.
     * 
     * @return street
     */
    public java.lang.String getStreet() {
        return street;
    }


    /**
     * Sets the street value for this Contact.
     * 
     * @param street
     */
    public void setStreet(java.lang.String street) {
        this.street = street;
    }


    /**
     * Gets the postalAddress value for this Contact.
     * 
     * @return postalAddress
     */
    public java.lang.String getPostalAddress() {
        return postalAddress;
    }


    /**
     * Sets the postalAddress value for this Contact.
     * 
     * @param postalAddress
     */
    public void setPostalAddress(java.lang.String postalAddress) {
        this.postalAddress = postalAddress;
    }


    /**
     * Gets the postalCode value for this Contact.
     * 
     * @return postalCode
     */
    public java.lang.String getPostalCode() {
        return postalCode;
    }


    /**
     * Sets the postalCode value for this Contact.
     * 
     * @param postalCode
     */
    public void setPostalCode(java.lang.String postalCode) {
        this.postalCode = postalCode;
    }


    /**
     * Gets the homePostalAddress value for this Contact.
     * 
     * @return homePostalAddress
     */
    public java.lang.String getHomePostalAddress() {
        return homePostalAddress;
    }


    /**
     * Sets the homePostalAddress value for this Contact.
     * 
     * @param homePostalAddress
     */
    public void setHomePostalAddress(java.lang.String homePostalAddress) {
        this.homePostalAddress = homePostalAddress;
    }


    /**
     * Gets the title value for this Contact.
     * 
     * @return title
     */
    public java.lang.String getTitle() {
        return title;
    }


    /**
     * Sets the title value for this Contact.
     * 
     * @param title
     */
    public void setTitle(java.lang.String title) {
        this.title = title;
    }


    /**
     * Gets the homePhone value for this Contact.
     * 
     * @return homePhone
     */
    public java.lang.String getHomePhone() {
        return homePhone;
    }


    /**
     * Sets the homePhone value for this Contact.
     * 
     * @param homePhone
     */
    public void setHomePhone(java.lang.String homePhone) {
        this.homePhone = homePhone;
    }


    /**
     * Gets the description value for this Contact.
     * 
     * @return description
     */
    public java.lang.String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this Contact.
     * 
     * @param description
     */
    public void setDescription(java.lang.String description) {
        this.description = description;
    }


    /**
     * Gets the secretary value for this Contact.
     * 
     * @return secretary
     */
    public java.lang.String getSecretary() {
        return secretary;
    }


    /**
     * Sets the secretary value for this Contact.
     * 
     * @param secretary
     */
    public void setSecretary(java.lang.String secretary) {
        this.secretary = secretary;
    }


    /**
     * Gets the pager value for this Contact.
     * 
     * @return pager
     */
    public java.lang.String getPager() {
        return pager;
    }


    /**
     * Sets the pager value for this Contact.
     * 
     * @param pager
     */
    public void setPager(java.lang.String pager) {
        this.pager = pager;
    }


    /**
     * Gets the employeeType value for this Contact.
     * 
     * @return employeeType
     */
    public java.lang.String getEmployeeType() {
        return employeeType;
    }


    /**
     * Sets the employeeType value for this Contact.
     * 
     * @param employeeType
     */
    public void setEmployeeType(java.lang.String employeeType) {
        this.employeeType = employeeType;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof Contact)) return false;
        Contact other = (Contact) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.uid==null && other.getUid()==null) || 
             (this.uid!=null &&
              this.uid.equals(other.getUid()))) &&
            ((this.email1Address==null && other.getEmail1Address()==null) || 
             (this.email1Address!=null &&
              this.email1Address.equals(other.getEmail1Address()))) &&
            ((this.email2Address==null && other.getEmail2Address()==null) || 
             (this.email2Address!=null &&
              this.email2Address.equals(other.getEmail2Address()))) &&
            ((this.email3Address==null && other.getEmail3Address()==null) || 
             (this.email3Address!=null &&
              this.email3Address.equals(other.getEmail3Address()))) &&
            ((this.displayName==null && other.getDisplayName()==null) || 
             (this.displayName!=null &&
              this.displayName.equals(other.getDisplayName()))) &&
            ((this.surname==null && other.getSurname()==null) || 
             (this.surname!=null &&
              this.surname.equals(other.getSurname()))) &&
            ((this.givenname==null && other.getGivenname()==null) || 
             (this.givenname!=null &&
              this.givenname.equals(other.getGivenname()))) &&
            ((this.mobile==null && other.getMobile()==null) || 
             (this.mobile!=null &&
              this.mobile.equals(other.getMobile()))) &&
            ((this.telephoneNumber==null && other.getTelephoneNumber()==null) || 
             (this.telephoneNumber!=null &&
              this.telephoneNumber.equals(other.getTelephoneNumber()))) &&
            ((this.facsimileTelephoneNumber==null && other.getFacsimileTelephoneNumber()==null) || 
             (this.facsimileTelephoneNumber!=null &&
              this.facsimileTelephoneNumber.equals(other.getFacsimileTelephoneNumber()))) &&
            ((this.o==null && other.getO()==null) || 
             (this.o!=null &&
              this.o.equals(other.getO()))) &&
            ((this.ou==null && other.getOu()==null) || 
             (this.ou!=null &&
              this.ou.equals(other.getOu()))) &&
            ((this.street==null && other.getStreet()==null) || 
             (this.street!=null &&
              this.street.equals(other.getStreet()))) &&
            ((this.postalAddress==null && other.getPostalAddress()==null) || 
             (this.postalAddress!=null &&
              this.postalAddress.equals(other.getPostalAddress()))) &&
            ((this.postalCode==null && other.getPostalCode()==null) || 
             (this.postalCode!=null &&
              this.postalCode.equals(other.getPostalCode()))) &&
            ((this.homePostalAddress==null && other.getHomePostalAddress()==null) || 
             (this.homePostalAddress!=null &&
              this.homePostalAddress.equals(other.getHomePostalAddress()))) &&
            ((this.title==null && other.getTitle()==null) || 
             (this.title!=null &&
              this.title.equals(other.getTitle()))) &&
            ((this.homePhone==null && other.getHomePhone()==null) || 
             (this.homePhone!=null &&
              this.homePhone.equals(other.getHomePhone()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.secretary==null && other.getSecretary()==null) || 
             (this.secretary!=null &&
              this.secretary.equals(other.getSecretary()))) &&
            ((this.pager==null && other.getPager()==null) || 
             (this.pager!=null &&
              this.pager.equals(other.getPager()))) &&
            ((this.employeeType==null && other.getEmployeeType()==null) || 
             (this.employeeType!=null &&
              this.employeeType.equals(other.getEmployeeType())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUid() != null) {
            _hashCode += getUid().hashCode();
        }
        if (getEmail1Address() != null) {
            _hashCode += getEmail1Address().hashCode();
        }
        if (getEmail2Address() != null) {
            _hashCode += getEmail2Address().hashCode();
        }
        if (getEmail3Address() != null) {
            _hashCode += getEmail3Address().hashCode();
        }
        if (getDisplayName() != null) {
            _hashCode += getDisplayName().hashCode();
        }
        if (getSurname() != null) {
            _hashCode += getSurname().hashCode();
        }
        if (getGivenname() != null) {
            _hashCode += getGivenname().hashCode();
        }
        if (getMobile() != null) {
            _hashCode += getMobile().hashCode();
        }
        if (getTelephoneNumber() != null) {
            _hashCode += getTelephoneNumber().hashCode();
        }
        if (getFacsimileTelephoneNumber() != null) {
            _hashCode += getFacsimileTelephoneNumber().hashCode();
        }
        if (getO() != null) {
            _hashCode += getO().hashCode();
        }
        if (getOu() != null) {
            _hashCode += getOu().hashCode();
        }
        if (getStreet() != null) {
            _hashCode += getStreet().hashCode();
        }
        if (getPostalAddress() != null) {
            _hashCode += getPostalAddress().hashCode();
        }
        if (getPostalCode() != null) {
            _hashCode += getPostalCode().hashCode();
        }
        if (getHomePostalAddress() != null) {
            _hashCode += getHomePostalAddress().hashCode();
        }
        if (getTitle() != null) {
            _hashCode += getTitle().hashCode();
        }
        if (getHomePhone() != null) {
            _hashCode += getHomePhone().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getSecretary() != null) {
            _hashCode += getSecretary().hashCode();
        }
        if (getPager() != null) {
            _hashCode += getPager().hashCode();
        }
        if (getEmployeeType() != null) {
            _hashCode += getEmployeeType().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(Contact.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("http://localhost/mapicontactsldapsoap", "contact"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("uid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "uid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("email1Address");
        elemField.setXmlName(new javax.xml.namespace.QName("", "email1address"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("email2Address");
        elemField.setXmlName(new javax.xml.namespace.QName("", "email2address"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("email3Address");
        elemField.setXmlName(new javax.xml.namespace.QName("", "email3address"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "displayName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("surname");
        elemField.setXmlName(new javax.xml.namespace.QName("", "surname"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("givenname");
        elemField.setXmlName(new javax.xml.namespace.QName("", "givenname"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mobile");
        elemField.setXmlName(new javax.xml.namespace.QName("", "mobile"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("telephoneNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "telephoneNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("facsimileTelephoneNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "facsimileTelephoneNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("o");
        elemField.setXmlName(new javax.xml.namespace.QName("", "o"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ou");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ou"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("street");
        elemField.setXmlName(new javax.xml.namespace.QName("", "street"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("postalAddress");
        elemField.setXmlName(new javax.xml.namespace.QName("", "postalAddress"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("postalCode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "postalCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("homePostalAddress");
        elemField.setXmlName(new javax.xml.namespace.QName("", "homePostalAddress"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("title");
        elemField.setXmlName(new javax.xml.namespace.QName("", "title"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("homePhone");
        elemField.setXmlName(new javax.xml.namespace.QName("", "homePhone"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("secretary");
        elemField.setXmlName(new javax.xml.namespace.QName("", "secretary"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("pager");
        elemField.setXmlName(new javax.xml.namespace.QName("", "pager"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("employeeType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "employeeType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
