/***************************************************************************
 *   Copyright (C) 2010 by                                                 *
 *                                                                         *
 *   catWorkX GmbH, Schellerdamm 16, 21079 Hamburg                         *                                                                         
 *   Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>                    *
 *                                                                         *
 *   This code is part of the Zarafa 2 LDAP tool, which is able to export  *
 *   private and/or public contacts from Zarafa to a LDAP server           * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Affero General Public License as        *
 *   published by the Free Software Foundation; either version 3           *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU AFFERO GENERAL PUBLIC LICENSE for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Affero General Public      *
 *   License along with this program.  If not, see                         *
 *   <http://www.gnu.org/licenses/>                                        *
 *                                                                         *
 ***************************************************************************/

package de.catworkx.zarafa.zarafa2ldap;

public class MapiConnect {

	MapicontactsldapsoapBindingStub mapi = null;
	
	public MapiConnect(String address) {
		try {
			MapicontactsldapsoapLocator serviceLocator = new MapicontactsldapsoapLocator();
			serviceLocator.setmapicontactsldapsoapPortEndpointAddress(address);
			MapicontactsldapsoapBindingStub server = (MapicontactsldapsoapBindingStub)serviceLocator.getmapicontactsldapsoapPort();
			System.out.println("");
			this.mapi = server;
		} catch (Exception e) {
			e.printStackTrace();
		}	
	}
	
	public Users[] getPrivateContacts() {
		Users[] users = null;
		try {
			users = this.mapi.getPrivateContactFolders();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return users;
		
	}
	
	public Folders[] getPublicContacts() {
		Folders[] users = null;
		try {
			users = this.mapi.getPublicContactFolders();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return users;
		
	}
	
}
